include \masm32\include\masm32rt.inc

WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data?
hInstance	dd ?
hStatic	dd ?
hEdit	dd ?
MailBufferTmp	dd 400 dup(?)
MailBuffer	dd 400 dup(?)

.code
MailTo	db "mailto:hutch@movsd.com?Subject=Happy%20Birthday&Body=Dear%20Hutch%2c%0d%0a%0d%0a", 0
start:	call CreateMyStatic	; the MyStatic class used in the rc file must be registered before calling DialogBoxParam
	invoke DialogBoxParam, hInstance, chr$("TestWin"), 0, ADDR WndProc, 0	; Call the dialog box stored in resource file
	invoke ExitProcess, eax

WndProc proc uses ebx hWin, uMsg, wParam, lParam
	mov ebx, lParam
	SWITCH uMsg
	CASE WM_INITDIALOG
		invoke GetDlgItem, hWin, 100
		mov hEdit, eax
		invoke GetDlgItem, hWin, 127
		mov hStatic, eax
		mov ebx, eax
		xor eax, eax
		invoke CreateFont, -14, eax, eax, eax, eax, eax, 1, eax, eax, eax, eax, eax, eax, eax
		invoke SendMessage, ebx, WM_SETFONT, eax, 1
		invoke SendMessage, hEdit, WM_SETTEXT, 0, chr$("<Max. 1000 characters>")
	CASE WM_COMMAND
		.if ebx==hStatic			; ebx=lParam
			call MailMyText
		.endif
	CASE WM_CTLCOLORSTATIC
		.if ebx==hStatic			; ebx=lParam
			invoke SetTextColor, wParam, 0FF0000h	; BGR
			invoke SetBkMode, wParam, TRANSPARENT
			invoke GetStockObject, HOLLOW_BRUSH
			jmp @F
		.endif
	CASE WM_CLOSE
		invoke EndDialog, hWin, 0
	ENDSW
	xor eax, eax
@@:	ret
WndProc endp

MailMyText proc
	pushad
	mov edi, offset MailBuffer
	mov esi, offset MailBufferTmp
	invoke lstrcpy, edi, offset MailTo
	add edi, len(edi)
	push eax	; len
	invoke SendMessage, hEdit, WM_GETTEXT, 1200, esi
	pop eax
	mov ecx, 1024+250	; 1024+252 works, 1024+254 fails
	sub ecx, eax			; rest len
	.Repeat
		lodsb
		.if (al>="0" && al<="9") || (al>="a" && al<="z") || (al>="A" && al<="Z")
;			nop
		.elseif al
			mov byte ptr [edi], "%"
			inc edi
			mov dl, al
			shr al, 4
			.if al>9
				add al, "A"-10
			.else
				add al, "0"
			.endif
			stosb
			xchg eax, edx
			and al, 0Fh
			.if al>9
				add al, "A"-10
			.else
				add al, "0"
			.endif
		.endif
		stosb
		dec ecx
	.Until Zero? || !al
	m2m eax, IDYES
	mov byte ptr [edi], ah
	.if !ecx
		MsgBox 0, chr$("Message body truncated to 1024 chars.", 13, 10, "Send anyway?"), "SendMail", MB_YESNO
	.endif
	.if eax==IDYES
		invoke ShellExecute, 0, 0, offset MailBuffer, 0, 0, SW_SHOWDEFAULT
	.endif
	popad
	ret
MailMyText endp

CreateMyStatic proc uses esi edi
LOCAL wc:WNDCLASSEX
	lea edi, wc
	mov [edi.WNDCLASSEX.cbSize], sizeof wc
	invoke GetModuleHandle, 0
	mov hInstance, eax
	mov esi, chr$("MyStatic")
	lea edx, [esi+2]
	invoke GetClassInfoEx, eax, edx, edi		; edx = Static
	mov [edi.WNDCLASSEX.lpszClassName], esi	; esi = MyStatic
	invoke LoadCursor, 0, IDC_HAND
	mov [edi.WNDCLASSEX.hCursor], eax
	invoke RegisterClassEx, edi
	ret
CreateMyStatic endp

end start
